Index: codes/icosagcm/trunk/src/transfert_mpi.f90
===================================================================
--- codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 185)
+++ codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 186)
@@ -8,16 +8,17 @@
     INTEGER         :: domain
     INTEGER         :: rank
+    INTEGER         :: tag
     INTEGER         :: size
+    INTEGER         :: offset
+    INTEGER         :: ireq
     INTEGER,POINTER :: buffer(:)
-    REAL,POINTER    :: buffer_r2(:)
-    REAL,POINTER    :: buffer_r3(:,:)
-    REAL,POINTER    :: buffer_r4(:,:,:)
+    REAL,POINTER    :: buffer_r(:)
     INTEGER,POINTER :: src_value(:)
   END TYPE array
   
   TYPE t_buffer
-    REAL,POINTER    :: r2(:)
-    REAL,POINTER    :: r3(:,:)
-    REAL,POINTER    :: r4(:,:,:)
+    REAL,POINTER    :: r(:)
+    INTEGER         :: size
+    INTEGER         :: rank
   END TYPE t_buffer    
     
@@ -39,18 +40,30 @@
     INTEGER :: nsend
     INTEGER :: nreq_mpi
+    INTEGER :: nreq_send
+    INTEGER :: nreq_recv
     TYPE(ARRAY),POINTER :: send(:)
   END TYPE t_request
   
-  TYPE(t_request),POINTER :: req_i1(:)
-  TYPE(t_request),POINTER :: req_e1_scal(:)
-  TYPE(t_request),POINTER :: req_e1_vect(:)
-  
-  TYPE(t_request),POINTER :: req_i0(:)
-  TYPE(t_request),POINTER :: req_e0_scal(:)
-  TYPE(t_request),POINTER :: req_e0_vect(:)
+  TYPE(t_request),SAVE,POINTER :: req_i1(:)
+  TYPE(t_request),SAVE,POINTER :: req_e1_scal(:)
+  TYPE(t_request),SAVE,POINTER :: req_e1_vect(:)
+  
+  TYPE(t_request),SAVE,POINTER :: req_i0(:)
+  TYPE(t_request),SAVE,POINTER :: req_e0_scal(:)
+  TYPE(t_request),SAVE,POINTER :: req_e0_vect(:)
+
+  TYPE t_reorder
+    INTEGER :: ind
+    INTEGER :: rank
+    INTEGER :: tag
+    INTEGER :: isend
+  END TYPE t_reorder  
   
   TYPE t_message
     TYPE(t_request), POINTER :: request(:)
     INTEGER :: nreq
+    INTEGER :: nreq_send
+    INTEGER :: nreq_recv
+    TYPE(t_reorder), POINTER :: reorder(:)
     INTEGER, POINTER :: mpi_req(:)
     INTEGER, POINTER :: status(:,:)
@@ -62,8 +75,7 @@
   END TYPE t_message
   
-  INTEGER,SAVE :: message_number=0 ;
-  
 CONTAINS
-  
+       
+      
   SUBROUTINE init_transfert
   USE domain_mod
@@ -72,6 +84,8 @@
   USE metric
   USE mpipara
+  USE mpi_mod
   IMPLICIT NONE
   INTEGER :: ind,i,j
+  LOGICAL ::ok
  
     CALL create_request(field_t,req_i1)
@@ -410,4 +424,5 @@
     INTEGER :: nb_domain_recv(0:mpi_size-1)
     INTEGER :: nb_domain_send(0:mpi_size-1)
+    INTEGER :: tag_rank(0:mpi_size-1)
     INTEGER :: nb_data_domain_recv(ndomain_glo)
     INTEGER :: list_domain_recv(ndomain_glo)
@@ -415,10 +430,14 @@
     INTEGER             :: list_domain(ndomain)
 
-    INTEGER :: rank,i,j
+    INTEGER :: rank,i,j,pos
     INTEGER :: size_,ind_glo,ind_loc, ind_src
-    INTEGER :: isend, irecv, ireq, nreq
+    INTEGER :: isend, irecv, ireq, nreq, nsend, nrecv
     INTEGER, ALLOCATABLE :: mpi_req(:)
     INTEGER, ALLOCATABLE :: status(:,:)
-    
+    INTEGER, ALLOCATABLE :: rank_list(:)
+    INTEGER, ALLOCATABLE :: offset(:)
+    LOGICAL,PARAMETER :: debug = .FALSE.
+
+ 
     IF (.NOT. using_mpi) RETURN
     
@@ -428,4 +447,5 @@
       nb_data_domain_recv(:) = 0
       nb_domain_recv(:) = 0
+      tag_rank(:)=0
       
       DO i=1,req%size
@@ -486,4 +506,5 @@
     ALLOCATE(status(MPI_STATUS_SIZE,nreq))
     
+
     ireq=0
     DO ind_loc=1,ndomain
@@ -492,7 +513,9 @@
         ireq=ireq+1
         CALL MPI_ISEND(req%recv(irecv)%domain,1,MPI_INTEGER,req%recv(irecv)%rank,0,comm_icosa, mpi_req(ireq),ierr)
+        IF (debug) PRINT *,"Isend ",req%recv(irecv)%domain, "from ", mpi_rank, "to ",req%recv(irecv)%rank, "tag ",0
       ENDDO
     ENDDO
-    
+
+    IF (debug) PRINT *,"------------"    
     j=0
     DO rank=0,mpi_size-1
@@ -501,6 +524,8 @@
         ireq=ireq+1
         CALL MPI_IRECV(list_domain_send(j),1,MPI_INTEGER,rank,0,comm_icosa, mpi_req(ireq),ierr)
+        IF (debug) PRINT *,"IRecv ",list_domain_send(j), "from ", rank, "to ",mpi_rank, "tag ",0
       ENDDO
     ENDDO
+    IF (debug) PRINT *,"------------"    
     
     CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
@@ -517,4 +542,6 @@
       ALLOCATE(req%send(req%nsend))
     ENDDO
+
+    IF (debug) PRINT *,"------------"    
    
    ireq=0 
@@ -525,14 +552,21 @@
        ireq=ireq+1
        CALL MPI_ISEND(mpi_rank,1,MPI_INTEGER,req%recv(irecv)%rank,req%recv(irecv)%domain,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"Isend ",mpi_rank, "from ", mpi_rank, "to ",req%recv(irecv)%rank,"tag ",req%recv(irecv)%domain
      ENDDO
+    IF (debug) PRINT *,"------------"    
      
      DO isend=1,req%nsend
        ireq=ireq+1
        CALL MPI_IRECV(req%send(isend)%rank,1,MPI_INTEGER,MPI_ANY_SOURCE,ind_loc,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"IRecv ",req%send(isend)%rank, "from ", "xxx", "to ",mpi_rank, "tag ",ind_loc
      ENDDO
    ENDDO
 
+   IF (debug) PRINT *,"------------"    
+
    CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
    CALL MPI_BARRIER(comm_icosa,ierr)
+
+   IF (debug) PRINT *,"------------"    
 
    ireq=0 
@@ -543,14 +577,47 @@
        ireq=ireq+1
        CALL MPI_ISEND(ind_loc,1,MPI_INTEGER,req%recv(irecv)%rank,req%recv(irecv)%domain,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"Isend ",ind_loc, "from ", mpi_rank, "to ",req%recv(irecv)%rank,"tag ",req%recv(irecv)%domain
      ENDDO
+
+     IF (debug) PRINT *,"------------"    
      
      DO isend=1,req%nsend
        ireq=ireq+1
        CALL MPI_IRECV(req%send(isend)%domain,1,MPI_INTEGER,req%send(isend)%rank,ind_loc,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"IRecv ",req%send(isend)%domain, "from ", req%send(isend)%rank, "to ",mpi_rank, "tag ",ind_loc
      ENDDO
    ENDDO
+   IF (debug) PRINT *,"------------"    
    
    CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
    CALL MPI_BARRIER(comm_icosa,ierr)
+   IF (debug) PRINT *,"------------"    
+
+   ireq=0
+   DO ind_loc=1,ndomain
+     req=>request(ind_loc)
+     
+     DO irecv=1,req%nrecv
+       ireq=ireq+1
+       req%recv(irecv)%tag=tag_rank(req%recv(irecv)%rank)
+       tag_rank(req%recv(irecv)%rank)=tag_rank(req%recv(irecv)%rank)+1
+       CALL MPI_ISEND(req%recv(irecv)%tag,1,MPI_INTEGER,req%recv(irecv)%rank,req%recv(irecv)%domain,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"Isend ",req%recv(irecv)%tag, "from ", mpi_rank, "to ",req%recv(irecv)%rank,"tag ",req%recv(irecv)%domain
+     ENDDO
+   IF (debug) PRINT *,"------------"    
+     
+     DO isend=1,req%nsend
+       ireq=ireq+1
+       CALL MPI_IRECV(req%send(isend)%tag,1,MPI_INTEGER,req%send(isend)%rank,ind_loc,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"IRecv ",req%send(isend)%tag, "from ", req%send(isend)%rank, "to ",mpi_rank, "tag ",ind_loc
+     ENDDO
+   ENDDO
+   IF (debug) PRINT *,"------------"    
+   
+   CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
+   CALL MPI_BARRIER(comm_icosa,ierr)
+
+
+   IF (debug) PRINT *,"------------"    
 
    ireq=0 
@@ -560,10 +627,13 @@
      DO irecv=1,req%nrecv
        ireq=ireq+1
-       CALL MPI_ISEND(req%recv(irecv)%size,1,MPI_INTEGER,req%recv(irecv)%rank,req%recv(irecv)%domain,comm_icosa, mpi_req(ireq),ierr)
+       CALL MPI_ISEND(req%recv(irecv)%size,1,MPI_INTEGER,req%recv(irecv)%rank,req%recv(irecv)%tag,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"Isend ",req%recv(irecv)%size, "from ", mpi_rank, "to ",req%recv(irecv)%rank,"tag ",req%recv(irecv)%domain
      ENDDO
+     IF (debug) PRINT *,"------------"    
      
      DO isend=1,req%nsend
        ireq=ireq+1
-       CALL MPI_IRECV(req%send(isend)%size,1,MPI_INTEGER,req%send(isend)%rank,ind_loc,comm_icosa, mpi_req(ireq),ierr)
+       CALL MPI_IRECV(req%send(isend)%size,1,MPI_INTEGER,req%send(isend)%rank,req%send(isend)%tag,comm_icosa, mpi_req(ireq),ierr)
+       IF (debug) PRINT *,"IRecv ",req%send(isend)%size, "from ", req%send(isend)%rank, "to ",mpi_rank, "tag ",ind_loc
      ENDDO
    ENDDO
@@ -578,5 +648,5 @@
        ireq=ireq+1
        CALL MPI_ISEND(req%recv(irecv)%value,req%recv(irecv)%size,MPI_INTEGER,&
-            req%recv(irecv)%rank,req%recv(irecv)%domain,comm_icosa, mpi_req(ireq),ierr)
+            req%recv(irecv)%rank,req%recv(irecv)%tag,comm_icosa, mpi_req(ireq),ierr)
      ENDDO
      
@@ -585,5 +655,5 @@
        ALLOCATE(req%send(isend)%value(req%send(isend)%size))
        CALL MPI_IRECV(req%send(isend)%value,req%send(isend)%size,MPI_INTEGER,&
-            req%send(isend)%rank,ind_loc,comm_icosa, mpi_req(ireq),ierr)
+            req%send(isend)%rank,req%send(isend)%tag,comm_icosa, mpi_req(ireq),ierr)
      ENDDO
    ENDDO
@@ -600,6 +670,7 @@
      ENDDO
    ENDDO  
-
-! domain is on the same mpi process
+   
+
+! domain is on the same mpi process => copie memory to memory
    
    DO ind_loc=1,ndomain
@@ -611,7 +682,8 @@
            req_src=>request(req%recv(irecv)%domain)
            DO isend=1,req_src%nsend
-             IF (req_src%send(isend)%rank==mpi_rank .AND. req_src%send(isend)%domain==ind_loc) THEN
+             IF (req_src%send(isend)%rank==mpi_rank .AND. req_src%send(isend)%tag==req%recv(irecv)%tag) THEN
                req%recv(irecv)%src_value => req_src%send(isend)%value
                IF ( size(req%recv(irecv)%value) /= size(req_src%send(isend)%value)) THEN
+                 PRINT *,ind_loc, irecv, isend, size(req%recv(irecv)%value), size(req_src%send(isend)%value)
                  STOP "size(req%recv(irecv)%value) /= size(req_src%send(isend)%value"
                ENDIF
@@ -624,17 +696,102 @@
    
 ! true number of mpi request
+
+   request(:)%nreq_mpi=0
+   request(:)%nreq_send=0
+   request(:)%nreq_recv=0
+   ALLOCATE(rank_list(sum(request(:)%nsend)))
+   ALLOCATE(offset(sum(request(:)%nsend)))
+   offset(:)=0
+   
+   nsend=0
    DO ind_loc=1,ndomain
      req=>request(ind_loc)
-     req%nreq_mpi=0
 
      DO isend=1,req%nsend
-      IF (req%send(isend)%rank/=mpi_rank .OR. .TRUE.) req%nreq_mpi=req%nreq_mpi+1  
+       IF (req%send(isend)%rank/=mpi_rank) THEN
+         pos=0
+         DO i=1,nsend
+           IF (req%send(isend)%rank==rank_list(i)) EXIT
+           pos=pos+1
+         ENDDO
+        
+         IF (pos==nsend) THEN
+           nsend=nsend+1
+           req%nreq_mpi=req%nreq_mpi+1
+           req%nreq_send=req%nreq_send+1
+           IF (mpi_threading_mode==MPI_THREAD_FUNNELED) THEN
+             rank_list(nsend)=req%send(isend)%rank
+           ELSE
+             rank_list(nsend)=-1
+           ENDIF
+         ENDIF
+         
+         pos=pos+1
+         req%send(isend)%ireq=pos
+         req%send(isend)%offset=offset(pos)
+         offset(pos)=offset(pos)+req%send(isend)%size
+       ENDIF
      ENDDO
-     
+   ENDDO
+
+   DEALLOCATE(rank_list)
+   DEALLOCATE(offset)
+     
+   ALLOCATE(rank_list(sum(request(:)%nrecv)))
+   ALLOCATE(offset(sum(request(:)%nrecv)))
+   offset(:)=0
+   
+   nrecv=0
+   DO ind_loc=1,ndomain
+     req=>request(ind_loc)
+
      DO irecv=1,req%nrecv
-      IF (req%recv(irecv)%rank/=mpi_rank .OR. .TRUE.) req%nreq_mpi=req%nreq_mpi+1  
+       IF (req%recv(irecv)%rank/=mpi_rank) THEN
+         pos=0
+         DO i=1,nrecv
+           IF (req%recv(irecv)%rank==rank_list(i)) EXIT
+           pos=pos+1
+         ENDDO
+        
+         IF (pos==nrecv) THEN
+           nrecv=nrecv+1
+           req%nreq_mpi=req%nreq_mpi+1
+           req%nreq_recv=req%nreq_recv+1
+           IF (mpi_threading_mode==MPI_THREAD_FUNNELED) THEN
+             rank_list(nrecv)=req%recv(irecv)%rank
+           ELSE
+             rank_list(nrecv)=-1
+           ENDIF
+         ENDIF
+        
+         pos=pos+1
+         req%recv(irecv)%ireq=nsend+pos
+         req%recv(irecv)%offset=offset(pos)
+         offset(pos)=offset(pos)+req%recv(irecv)%size
+       ENDIF
      ENDDO
-  
    ENDDO 
+
+! get the offsets   
+
+   ireq=0 
+   DO ind_loc=1,ndomain
+     req=>request(ind_loc)
+     
+     DO irecv=1,req%nrecv
+       ireq=ireq+1
+       CALL MPI_ISEND(req%recv(irecv)%offset,1,MPI_INTEGER,&
+            req%recv(irecv)%rank,req%recv(irecv)%tag,comm_icosa, mpi_req(ireq),ierr)
+     ENDDO
+     
+     DO isend=1,req%nsend
+       ireq=ireq+1
+       CALL MPI_IRECV(req%send(isend)%offset,1,MPI_INTEGER,&
+            req%send(isend)%rank,req%send(isend)%tag,comm_icosa, mpi_req(ireq),ierr)
+     ENDDO
+   ENDDO
+
+   CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
+      
        
   END SUBROUTINE Finalize_request 
@@ -701,4 +858,6 @@
   END SUBROUTINE transfert_message_seq    
     
+
+
     
   SUBROUTINE init_message_mpi(field,request, message)
@@ -717,97 +876,165 @@
     TYPE(t_request),POINTER :: req
     INTEGER :: irecv,isend
-    INTEGER :: ireq,nreq
+    INTEGER :: ireq,nreq, nreq_send
     INTEGER :: ind
     INTEGER :: dim3,dim4
-
+    INTEGER :: i,j
+    INTEGER :: message_number
+!    TYPE(t_reorder),POINTER :: reorder(:)
+!    TYPE(t_reorder) :: reorder_swap
+
+!$OMP BARRIER
 !$OMP MASTER
     message%number=message_number
     message_number=message_number+1
     IF (message_number==100) message_number=0
-    
+
+  
     message%request=>request
-    nreq=sum(request(:)%nsend)+sum(request(:)%nrecv)
-!    message%nreq=nreq
     message%nreq=sum(message%request(:)%nreq_mpi)
+    message%nreq_send=sum(message%request(:)%nreq_send)
+    message%nreq_recv=sum(message%request(:)%nreq_recv)
+    nreq=message%nreq
+
     ALLOCATE(message%mpi_req(nreq))
     ALLOCATE(message%buffers(nreq))
     ALLOCATE(message%status(MPI_STATUS_SIZE,nreq))
-    
+    message%buffers(:)%size=0
     message%pending=.FALSE.
     message%completed=.FALSE.
-    
+  
+    DO ind=1,ndomain
+      req=>request(ind)
+      DO isend=1,req%nsend
+        IF (req%send(isend)%rank/=mpi_rank) THEN
+          ireq=req%send(isend)%ireq 
+          message%buffers(ireq)%size=message%buffers(ireq)%size+req%send(isend)%size
+          message%buffers(ireq)%rank=req%send(isend)%rank
+        ENDIF
+      ENDDO
+      DO irecv=1,req%nrecv
+        IF (req%recv(irecv)%rank/=mpi_rank) THEN
+          ireq=req%recv(irecv)%ireq 
+          message%buffers(ireq)%size=message%buffers(ireq)%size+req%recv(irecv)%size
+          message%buffers(ireq)%rank=req%recv(irecv)%rank
+        ENDIF
+      ENDDO
+    ENDDO
+
+
     IF (field(1)%data_type==type_real) THEN
 
       IF (field(1)%ndim==2) THEN
-      
-        ireq=0
-        DO ind=1,ndomain
-          req=>request(ind)
-      
-          DO isend=1,req%nsend
-            ireq=ireq+1
-            send=>req%send(isend)
-            CALL allocate_mpi_buffer(message%buffers(ireq)%r2,send%size)
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            CALL allocate_mpi_buffer(message%buffers(ireq)%r2,recv%size)
-          ENDDO
-        
-        ENDDO
-      
+     
+        DO ireq=1,message%nreq
+          CALL allocate_mpi_buffer(message%buffers(ireq)%r,message%buffers(ireq)%size)
+        ENDDO
       
       ELSE  IF (field(1)%ndim==3) THEN
-    
-        ireq=0
-        DO ind=1,ndomain
-          dim3=size(field(ind)%rval3d,2)
-          req=>request(ind)
- 
-          DO isend=1,req%nsend
-            ireq=ireq+1
-            send=>req%send(isend)
-            CALL allocate_mpi_buffer(message%buffers(ireq)%r3,send%size,dim3)
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            CALL allocate_mpi_buffer(message%buffers(ireq)%r3,recv%size,dim3)
-
-          ENDDO
-        
-        ENDDO
-
-
+      
+        dim3=size(field(1)%rval3d,2)
+        DO ireq=1,message%nreq
+          message%buffers(ireq)%size=message%buffers(ireq)%size*dim3
+          CALL allocate_mpi_buffer(message%buffers(ireq)%r,message%buffers(ireq)%size)
+        ENDDO
+      
       ELSE  IF (field(1)%ndim==4) THEN
-   
-        ireq=0
-        DO ind=1,ndomain
-          dim3=size(field(ind)%rval4d,2)
-          dim4=size(field(ind)%rval4d,3)
-          req=>request(ind)
-
-          DO isend=1,req%nsend
-            ireq=ireq+1
-            send=>req%send(isend)
-            CALL allocate_mpi_buffer(message%buffers(ireq)%r4,send%size,dim3,dim4)
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            CALL allocate_mpi_buffer(message%buffers(ireq)%r4,recv%size,dim3,dim4)
-          ENDDO
-        
-        ENDDO
-      
+        dim3=size(field(1)%rval4d,2)
+        dim4=size(field(1)%rval4d,3)
+        DO ireq=1,message%nreq
+          message%buffers(ireq)%size=message%buffers(ireq)%size*dim3*dim4
+          CALL allocate_mpi_buffer(message%buffers(ireq)%r,message%buffers(ireq)%size)
+        ENDDO
       ENDIF      
     ENDIF
+      
+         
+    
+! ! Reorder the request, so recv request are done in the same order than send request
+
+!    nreq_send=sum(request(:)%nsend)  
+!    message%nreq_send=nreq_send
+!    ALLOCATE(message%reorder(nreq_send))
+!    reorder=>message%reorder
+!    ireq=0
+!    DO ind=1,ndomain
+!      req=>request(ind)
+!      DO isend=1,req%nsend
+!        ireq=ireq+1
+!        reorder(ireq)%ind=ind
+!        reorder(ireq)%isend=isend
+!        reorder(ireq)%tag=req%send(isend)%tag
+!      ENDDO
+!    ENDDO
+
+! ! do a very very bad sort
+!    DO i=1,nreq_send-1
+!      DO j=i+1,nreq_send
+!        IF (reorder(i)%tag > reorder(j)%tag) THEN
+!          reorder_swap=reorder(i)
+!          reorder(i)=reorder(j)
+!          reorder(j)=reorder_swap
+!        ENDIF
+!      ENDDO
+!    ENDDO
+!    PRINT *,"reorder ",reorder(:)%tag
+    
+ 
 !$OMP END MASTER
 !$OMP BARRIER    
+
   END SUBROUTINE init_message_mpi
+  
+  SUBROUTINE Finalize_message_mpi(field,message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE mpi_mod
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_message) :: message
+
+    TYPE(t_request),POINTER :: req
+    INTEGER :: irecv,isend
+    INTEGER :: ireq,nreq
+    INTEGER :: ind
+
+!$OMP BARRIER
+!$OMP MASTER
+
+
+    IF (field(1)%data_type==type_real) THEN
+
+      IF (field(1)%ndim==2) THEN
+     
+        DO ireq=1,message%nreq
+          CALL free_mpi_buffer(message%buffers(ireq)%r)
+        ENDDO
+      
+      ELSE  IF (field(1)%ndim==3) THEN
+
+        DO ireq=1,message%nreq
+          CALL free_mpi_buffer(message%buffers(ireq)%r)
+        ENDDO
+      
+      ELSE  IF (field(1)%ndim==4) THEN
+
+        DO ireq=1,message%nreq
+          CALL free_mpi_buffer(message%buffers(ireq)%r)
+        ENDDO
+
+      ENDIF      
+    ENDIF
+    
+
+
+!$OMP END MASTER
+!$OMP BARRIER
+
+      
+  END SUBROUTINE Finalize_message_mpi
+
+
   
   SUBROUTINE barrier
@@ -845,257 +1072,5 @@
     REAL(rstd),POINTER :: rval3d(:,:), src_rval3d(:,:) 
     REAL(rstd),POINTER :: rval4d(:,:,:), src_rval4d(:,:,:) 
-    REAL(rstd),POINTER :: buffer_r2(:) 
-    REAL(rstd),POINTER :: buffer_r3(:,:) 
-    REAL(rstd),POINTER :: buffer_r4(:,:,:) 
-    INTEGER,POINTER :: value(:) 
-    INTEGER,POINTER :: sgn(:) 
-    TYPE(ARRAY),POINTER :: recv,send 
-    TYPE(t_request),POINTER :: req
-    INTEGER, ALLOCATABLE :: mpi_req(:)
-    INTEGER, ALLOCATABLE :: status(:,:)
-    INTEGER :: irecv,isend
-    INTEGER :: ireq,ireq_mpi,nreq
-    INTEGER :: ind,n,l,m
-    INTEGER :: dim3,dim4
-    INTEGER,POINTER :: src_value(:)
-    INTEGER,POINTER :: sign(:)
-
-!$OMP BARRIER
-
-    CALL trace_start("transfert_mpi")
-
-!    nreq=message%nreq
-    message%field=>field
-
-!$OMP MASTER
-    IF (message%nreq>0) THEN
-      message%completed=.FALSE.
-      message%pending=.TRUE.
-    ELSE
-      message%completed=.TRUE.
-      message%pending=.FALSE.
-    ENDIF
-    
-!$OMP END MASTER
-    
-    IF (field(1)%data_type==type_real) THEN
-      IF (field(1)%ndim==2) THEN
-
-        ireq=0
-        ireq_mpi=0
-        DO ind=1,ndomain
-          rval2d=>field(ind)%rval2d
-        
-          req=>message%request(ind)
-          DO isend=1,req%nsend
-            ireq=ireq+1
-            send=>req%send(isend)
-            value=>send%value
-
-            
-            IF (send%rank/=mpi_rank .OR. .TRUE.) THEN
-              ireq_mpi=ireq_mpi+1
-              buffer_r2=>message%buffers(ireq)%r2
-              CALL trace_in
-
-              !$OMP DO SCHEDULE(STATIC)
-              DO n=1,send%size
-                buffer_r2(n)=rval2d(value(n))
-              ENDDO
-            
-              CALL trace_out
-
-              !$OMP MASTER
-              CALL MPI_ISSEND(buffer_r2,send%size,MPI_REAL8,send%rank,ind+100*message%number,comm_icosa, message%mpi_req(ireq_mpi),ierr)
-              !$OMP END MASTER
-             
-             ENDIF
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-
-            IF (recv%rank==mpi_rank .AND. .FALSE.) THEN
-              value=>recv%value
-              src_value => recv%src_value
-              src_rval2d=>field(recv%domain)%rval2d
-              sgn=>recv%sign
-              !$OMP DO SCHEDULE(STATIC)
-              DO n=1,recv%size
-                rval2d(value(n))=src_rval2d(src_value(n))*sgn(n)
-              ENDDO
-            
-            ELSE
-               ireq_mpi=ireq_mpi+1
-               buffer_r2=>message%buffers(ireq)%r2
-              !$OMP MASTER
-              CALL MPI_IRECV(buffer_r2,recv%size,MPI_REAL8,recv%rank,recv%domain+100*message%number,comm_icosa, message%mpi_req(ireq_mpi),ierr)
-              !$OMP END MASTER
-            ENDIF
-          ENDDO
-        
-        ENDDO
-      
-      ELSE  IF (field(1)%ndim==3) THEN
-      
-        ireq=0
-        ireq_mpi=0
-        DO ind=1,ndomain
-          dim3=size(field(ind)%rval3d,2)
-          rval3d=>field(ind)%rval3d
-          req=>message%request(ind)
- 
-          DO isend=1,req%nsend
-            ireq=ireq+1
-            send=>req%send(isend)
-            value=>send%value
-
-            IF (send%rank/=mpi_rank .OR. .TRUE.) THEN
-              ireq_mpi=ireq_mpi+1
-              buffer_r3=>message%buffers(ireq)%r3
- 
-              CALL trace_in
-            
-!$OMP DO SCHEDULE(STATIC)
-                DO n=1,send%size
-                  buffer_r3(n,:)=rval3d(value(n),:)
-                ENDDO
-
-               CALL trace_out
-
-  !$OMP MASTER
-              CALL MPI_ISSEND(buffer_r3,send%size*dim3,MPI_REAL8,send%rank,ind+100*message%number,comm_icosa, message%mpi_req(ireq_mpi),ierr)
-  !$OMP END MASTER
-            ENDIF
-         ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-
-            IF (recv%rank==mpi_rank .AND. .FALSE.) THEN
-              value=>recv%value
-              src_value => recv%src_value
-              src_rval3d=>field(recv%domain)%rval3d
-              sgn=>recv%sign
-              !$OMP DO SCHEDULE(STATIC)
-              DO n=1,recv%size
-                rval3d(value(n),:)=src_rval3d(src_value(n),:)*sgn(n)
-              ENDDO
-            
-            ELSE
-              ireq_mpi=ireq_mpi+1
-              buffer_r3=>message%buffers(ireq)%r3
-!$OMP MASTER           
-              CALL MPI_IRECV(buffer_r3,recv%size*dim3,MPI_REAL8,recv%rank,recv%domain+100*message%number,comm_icosa, message%mpi_req(ireq_mpi),ierr)
-!$OMP END MASTER
-            ENDIF
-          ENDDO
-        
-        ENDDO
-
-      ELSE  IF (field(1)%ndim==4) THEN
-    
-        ireq=0
-        ireq_mpi=0
-        DO ind=1,ndomain
-          dim3=size(field(ind)%rval4d,2)
-          dim4=size(field(ind)%rval4d,3)
-          rval4d=>field(ind)%rval4d
-          req=>message%request(ind)
-
-          DO isend=1,req%nsend
-            ireq=ireq+1
-            send=>req%send(isend)
-            value=>send%value
-
-            IF (send%rank/=mpi_rank .OR. .TRUE.) THEN
-              ireq_mpi=ireq_mpi+1
-              buffer_r4=>message%buffers(ireq)%r4
-              CALL trace_in
-
-!$OMP DO SCHEDULE(STATIC)
-              DO n=1,send%size
-                 buffer_r4(n,:,:)=rval4d(value(n),:,:)
-              ENDDO
-
-             CALL trace_out
-
-!$OMP MASTER
-              CALL MPI_ISSEND(buffer_r4,send%size*dim3*dim4,MPI_REAL8,send%rank,ind+100*message%number,comm_icosa, message%mpi_req(ireq_mpi),ierr)
-!$OMP END MASTER
-            ENDIF
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            IF (recv%rank==mpi_rank .AND. .FALSE.) THEN
-              value=>recv%value
-              src_value => recv%src_value
-              src_rval4d=>field(recv%domain)%rval4d
-              sgn=>recv%sign
-
-              !$OMP DO SCHEDULE(STATIC)
-              DO n=1,recv%size
-                rval4d(value(n),:,:)=src_rval4d(src_value(n),:,:)*sgn(n)
-              ENDDO
-            
-            ELSE
-              ireq_mpi=ireq_mpi+1
-              buffer_r4=>message%buffers(ireq)%r4
-!$OMP MASTER           
-              CALL MPI_IRECV(buffer_r4,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%domain+100*message%number,comm_icosa, message%mpi_req(ireq_mpi),ierr)
-!$OMP END MASTER
-            ENDIF
-          ENDDO
-        
-        ENDDO
-      
-      ENDIF      
-      
-    ENDIF
-    IF (ireq_mpi /= message%nreq ) THEN
-      STOP "ireq_mpi /= message%nreq"
-    ENDIF
-    
-    CALL trace_end("transfert_mpi")
-!$OMP BARRIER
-    
-  END SUBROUTINE send_message_mpi
-  
-  SUBROUTINE test_message_mpi(message)
-  IMPLICIT NONE
-    TYPE(t_message) :: message
-    
-    INTEGER :: ierr
-!$OMP MASTER
-     IF (.NOT. message%pending) RETURN
-!$OMP END MASTER
-
-!$OMP MASTER
-     IF (.NOT. message%completed) CALL MPI_TESTALL(message%nreq,message%mpi_req,message%completed,message%status,ierr)
-!$OMP END MASTER
-  END SUBROUTINE  test_message_mpi
-  
-   
-  SUBROUTINE wait_message_mpi(message)
-  USE field_mod
-  USE domain_mod
-  USE mpi_mod
-  USE mpipara
-  USE omp_para
-  USE trace
-  IMPLICIT NONE
-    TYPE(t_message) :: message
-
-    TYPE(t_field),POINTER :: field(:)
-    REAL(rstd),POINTER :: rval2d(:) 
-    REAL(rstd),POINTER :: rval3d(:,:) 
-    REAL(rstd),POINTER :: rval4d(:,:,:) 
-    REAL(rstd),POINTER :: buffer_r2(:) 
-    REAL(rstd),POINTER :: buffer_r3(:,:) 
-    REAL(rstd),POINTER :: buffer_r4(:,:,:) 
+    REAL(rstd),POINTER :: buffer_r(:) 
     INTEGER,POINTER :: value(:) 
     INTEGER,POINTER :: sgn(:) 
